void gui() {

  cp5 = new ControlP5(this);


  // Crea el grupo de controles y define su tamaño y posición
  Group g3 = cp5.addGroup("Panel de Control")
    .setBackgroundColor(color(0, 64))
      .setBackgroundHeight(150)
        ;

  cp5.addBang("Axes")
    .setPosition(10, 10)
      .setSize(20, 20)
        .moveTo(g3)
          ;

  cp5.addBang("Grid")
    .setPosition(50, 10)
      .setSize(20, 20)
        .moveTo(g3)
          ;

  cp5.addBang("UnitCircle")
    .setPosition(90, 10)
      .setSize(20, 20)
        .moveTo(g3)
          ;
          
  cp5.addBang("Cromo")
    .setPosition(60, 90)
      .setSize(20, 40)
      .setColorBackground(255)
        .moveTo(g3)
          ;         
          
  cp5.addBang("PCS")
    .setPosition(30, 90)
      .setSize(20, 40)
        .moveTo(g3)
          ;                
  cp5.addBang("Loxodromic")
    .setPosition(370, 120)
      .setSize(40, 15)
        .moveTo(g3)
          ;  
  cp5.addBang("Hyperbolic")
    .setPosition(430, 120)
      .setSize(40, 15)
        .moveTo(g3)
        ;
  cp5.addBang("Parabolic")
    .setPosition(490, 120)
      .setSize(40, 15)
        .moveTo(g3)
          ;  
  cp5.addBang("Elliptic")
    .setPosition(550, 120)
      .setSize(40, 15)
        .moveTo(g3)
          ;  

  S1 = cp5.addSlider("Scale")
    .setPosition(10, 60)
      .setSize(100, 20)
        .setRange(25, 300)
          .setValue(25)
            .moveTo(g3)
              ;
  S2 = cp5.addSlider("PbyS")
    .setPosition(150, 5)
      .setSize(100, 20)
        .setRange(2,50)
          .setValue(2)
            .moveTo(g3)
              ;
  S3 = cp5.addSlider("SofS")
      .setPosition(150, 40)
      .setSize(100, 20)
        .setRange(1, 10)
          .setValue(1)
            .moveTo(g3)
              ;              
 
  S4 = cp5.addSlider("iterations")
  .    setPosition(150, 70)
      .setSize(100, 20)
        .setRange(1, 50)
          .setValue(1)
            .moveTo(g3)
              ;            
              
     cp5.addTextfield("aRe")
     .setPosition(300,10)
     .setSize(50,20)
     .setFont(createFont("Georgia",12))
     .setAutoClear(false)
     .moveTo(g3)
     ;
     
       cp5.addTextfield("aIm")
     .setPosition(360,10)
     .setSize(50,20)
     .setFont(createFont("Georgia",12))
     .setAutoClear(false)
     .moveTo(g3)
     ;
     
     cp5.addTextfield("bRe")
     .setPosition(450,10)
     .setSize(50,20)
     .setFont(createFont("Georgia",12))
     .setAutoClear(false)
     .moveTo(g3)
     ;
     
       cp5.addTextfield("bIm")
     .setPosition(510,10)
     .setSize(50,20)
     .setFont(createFont("Georgia",12))
     .setAutoClear(false)
     .moveTo(g3)
     ;
     
     cp5.addTextfield("cRe")
     .setPosition(300,60)
     .setSize(50,20)
     .setFont(createFont("Georgia",12))
     .setAutoClear(false)
     .moveTo(g3)
     ;
     
       cp5.addTextfield("cIm")
     .setPosition(360,60)
     .setSize(50,20)
     .setFont(createFont("Georgia",12))
     .setAutoClear(false)
     .moveTo(g3)
     ;
     
     cp5.addTextfield("dRe")
     .setPosition(450,60)
     .setSize(50,20)
     .setFont(createFont("Georgia",12))
     .setAutoClear(false)
     .moveTo(g3)
     ;
     
       cp5.addTextfield("dIm")
     .setPosition(510,60)
     .setSize(50,20)
     .setFont(createFont("Georgia",12))
     .setAutoClear(false)
     .moveTo(g3)
     ;
     
     trans = cp5.addTextlabel("label")
                    .setText("T(z)=("+aRe+"+ i* "+aIm+")z + ("+bRe+"+ i* "+bIm+") /("+cRe+"+ i* "+cIm+")z + ("+dRe+"+ i* "+dIm+")")
                    .setPosition(100,100)
                    .setColorValue(0xffff0000)
                    .setFont(createFont("Georgia",14))
                    .moveTo(g3)
                    ;
 

  // Barra que despliega controles
  accordion = cp5.addAccordion("acc")
    .setPosition(0, 0)
      .setWidth(width)
        .addItem(g3)
          ;
          
  cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      accordion.open(0);
    }
  }
  , 'o');
  cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      accordion.close(0);
    }
  }
  , 'c');
  
        cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      if(Scale<300){
      S1.setValue(Scale+1);
      }
    }
  }
  , 'w');
  
      cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      if(Scale>15){
      S1.setValue(Scale-1);
      }
    }
  }
  , 'q');
  
          cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      if(PbyS<180){
      S2.setValue(PbyS +1);
      println("Puntos por línea="+PbyS);
      }
    }
  }
  , 'r');
  
      cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      if(PbyS>2){
      S2.setValue(PbyS -1);
      println("Puntos por linea="+PbyS);
      }
    }
  }
  , 'e');
  
          cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      if(iterations<50){
      S4.setValue(iterations +1);
      println("Iterations="+iterations);
      }
    }
  }
  , 'y');
  
      cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      if(iterations>1){
      S4.setValue(iterations -1);
      println("Iterations="+iterations);}
    }
  }
  , 't');
  
            cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      if(SofS<11){
      S3.setValue(SofS +1);
      println("Size of Shape (lado/radio)="+SofS);
      }
    }
  }
  , 'j');
  
      cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      if(SofS>1){
      S3.setValue(SofS -1);
      println("Size of Shape (lado/radio)="+SofS);}
    }
  }
  , 'h');

      cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      Axes();
    }
  }
  , 'a');
  
  cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      Cromo();
    }
  }
  , 'f');
  
    cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      PCS();
    }
  }
  , 's');

      cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      Grid();
    }
  }
  , 'g');

      cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      UnitCircle();
    }
  }
  , 'u');

      cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      Photo();
    }
  }
  , 'p');
        cp5.mapKeyFor(new ControlKey() {
    public void keyEvent() {
      transformation = "custom";
      tindex=0;
    }
  }
  , ENTER);

  //accordion.close(0);

  // use Accordion.MULTI to allow multiple group 
  // to be open at a time.
  accordion.setCollapseMode(Accordion.MULTI);

  // when in SINGLE mode, only 1 accordion  
  // group can be open at a time.  
  // accordion.setCollapseMode(Accordion.SINGLE);
}

public void Axes() {
  c1 = !c1;
}
public void Grid() {
  c2 = !c2;
}
public void UnitCircle() {
  c3 = !c3;
}
public void Cromo() {
  Cromo = !Cromo;
}
public void PCS() {
  c6=(c6+1)%3;
}
public void Loxodromic() { //Loxo(.1+.8*I,0,-5+5*I,5-5*I) 6=PBYS 1=SOFS 21=It
 aRe = "0.127"; aIm = "-0.215";  bRe = "4.94"; bIm = "5.21";
cRe = "-0.104"; cIm = "0.0988"; dRe = "0.127"; dIm = "-0.215"; 
transformation = "loxodromic";
tindex=1;
}
public void Hyperbolic() { //Hyp(3,0,1-1*I,-1+1*I  Puntero=.5-.5*I  28=PbyS 1=SofS  5=Iterations
//scale = 97   cromo, circle
aRe = "1.67"; aIm = "0";  bRe = "-1.33"; bIm = "1.33";
cRe = "-0.667"; cIm = "-0.667"; dRe = "1.67"; dIm = "0";
transformation = "hyperbolic";
tindex=2;
}
public void Parabolic() { //Para(1,10,I,3-3*I) Puntero=2.32-4.84*I  18=PbyS 1=SofS  17=Iterations 
  aRe = "1.84"; aIm = "0.120";  bRe = "-2.88"; bIm = "2.16";
cRe = "0.120"; cIm = "0.160"; dRe = "0.160"; dIm = "-0.120"; 
transformation = "parabolic";
tindex=3;
}
public void Elliptic() { //Ell(17,0,-5,5) Puntero=-5-2.5*I  11=PbyS 1=SofS  8=Iterations
aRe = "-0.275"; aIm = "0";  bRe = "0"; bIm = "-4.81";
cRe = "0"; cIm = "-0.192"; dRe = "-0.275"; dIm = "0"; 
transformation = "elliptic";
tindex=4;

}
